<!--
{{ $base_url := $.Site.BaseURL }}
-->
<div
  x-data="{ auth: App.Auth }"
  class="mx-2"
>
  <!-- Unknown user -->
  <div x-show="!auth.isAuthenticated()" x-cloak>
    <a
      class="flex space-x-2 mx-2"
      x-bind:href="auth?.Session?.state?.login_url"
      @click="await auth.startLogin(await auth.createSession())"
    >
      <!-- User Icon -->
      <div class="inline-block relative">
        <div class="rounded-full w-8 -my-1 p-0 m-0 bg-white/75">
          {{ partial "icons/user.svg" . }}
        </div>
        <div class="absolute -bottom-3 -right-1.5">
          <i class="fa-solid fa-lock py-1 text-orange-500 font-bold"></i>
        </div>
      </div>

      <!-- Username label -->
      <span class="text-base text-gray-500/50"> Sign in </span>
    </a>
  </div>

  <!-- User profile -->
  <div
    class="relative"
    x-data="{    
      open: false,
      error: null,
      loading: false,
      profile: null,
      token: null,
      tokens: null
    }"
    x-init="
      await Promise.resolve(null)
        .then(async () => {
          loading = true;
          profile = await auth.getProfile();
          tokens = tokens || await App.Tokens.fetch();
          token = await await App.Tokens.get();
        })
        .catch(() => {
          error = ex;
          throw ex;
        })
        .finally(() => {
          loading = false
        })
    "
    x-show="auth?.isAuthenticated()"
    x-cloak
  >
    <div class="flex space-x-2 mx-2 cursor-pointer" @click="open = !open">
      <!-- User Icon -->
      <div class="inline-block relative">
        <div class="rounded-full w-8 -my-1 p-0 m-0 bg-white/75">
          <span x-cloak x-show="profile && !profile?.avatar_url">
            {{ partial "icons/user.svg" . }}
          </span>
          <img
            class="rounded-full object-cover object-center h-8"
            x-show="profile?.avatar_url"
            x-bind:src="profile?.avatar_url"
            x-bind:alt="profile?.name"
            x-cloak
          />
        </div>
        <div class="absolute -bottom-4 -right-2">
          <i
            class="fa-solid"
            :class="{ 
              'fa-circle-exclamation text-red-500 fa-bounce': error,
              'fa-rotate animate-spin text-blue-500': !error && loading,
              'fa-circle-check text-green-500': !error && !loading && token,
              'fa-lock text-red-500': !error && !loading && !token,
            }"
            x-bind:title="error?.message"
          ></i>
        </div>
      </div>

      <!-- Username label -->
      <span class="hidden lg:inline text-base font-bold" x-text="profile?.username"></span>
    </div>

    <!-- Dropdown content goes here -->
    <div
      x-cloak
      x-show="open"
      class="w-48 z-20 absolute left-0 top-10 shadow-lg bg-white ring-1 ring-black ring-opacity-5 space-y-1"
      @click.outside="open = false"
    >
      <!-- User Profile -->
      <a
        class="block px-4 py-2 text-gray-700 hover:bg-gray-100"
        href="{{ $base_url }}/user/login/"
      >
        <i class="fa-regular fa-address-card"></i>
        <span class="ml-1">User Profile</span>
      </a>

      <!-- User Tokens -->
      <div
        class="relative"
        x-data="{ open: false }"
        @mouseover="open = true"
        @mouseleave="open = false"
      >
        <div class="block px-4 py-2 text-gray-700 hover:bg-gray-100">
          <i class="fa-regular fa-key"></i>
          <span class="ml-1">Auth Tokens</span>
        </div>

        <!-- Dropdown for auth tokens -->
        <template x-if="open">
          <div
            x-init="tokens = tokens || await App.Tokens.fetch()"
            class="z-20 absolute w-60 -right-60 border top-0 shadow-lg bg-white ring-1 ring-black ring-opacity-5 space-y-1"
          >
            <template x-for="item in tokens || []">
              <div
                class="filtered block truncate text-gray-700 hover:bg-gray-100 active:bg-blue-100 cursor-pointer rounded-md"
                :class="{ 
                  'font-bold': item.description === token?.description,
                  'opacity-50': item.description !== token?.description,
                }"
                @click="
                  await App.Tokens.set(item); 
                  token = item;
                  open = false;
                "
              >
                <div class="flex items-center">
                  <i class="px-2 py-2 flex-0 fa-solid fa-key"></i>
                  <span
                    class="py-2 flex-1 truncate"
                    x-text="item.description"
                  ></span>
                  <a
                    class="px-2 py-2 flex-0 opacity-25 hover:opacity-75"
                    @click.stop="
                      let success = await App.Tokens.delete(item);                
                      if (success) {
                        $nextTick(async () => { 
                          if (token && token.id === item.id) {
                            token = null;
                          }
                          tokens = await App.Tokens.fetch();
                          open = false;
                        });
                      }    
                    "
                  >
                    <i class="fa-solid fa-trash"></i>
                  </a>
                </div>
              </div>
            </template>
            <hr x-show="tokens?.length" />
            <a
              class="block px-4 py-2 text-gray-700 hover:bg-gray-100 active:bg-blue-100 cursor-pointer rounded-md"
              @click="
                let desc = prompt('Choose a unique identifier for this token', 'Pipeline Token');
                if (tokens?.filter(t => t.description === desc).length) {
                  alert(`Trigger with description '${desc}' already exists.`);
                } else {
                  token = await App.Tokens.create(desc) || token;
                  tokens = await App.Tokens.fetch();
                  $nextTick(() => { open = false });
                }
              "
            >
              <i class="fa-solid fa-plus mr-1"></i>
              <span>Create Token</span>
            </a>
          </div>
        </template>
      </div>

      <hr />
      <a
        class="block px-4 py-2 text-gray-700 hover:bg-gray-100"
        @click="await auth.signOut(auth.Session)"
      >
        <i class="fa-solid fa-xmark"></i>
        <span class="ml-1">Sign Out</span>
      </a>
    </div>
  </div>
</div>
